package me.Demon.BlockWars.Data;

import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.GameUtil;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;

public class GiftData {

    private String giftName;
    private String event;
    private String comple_type;
    private String sounds;
    private int amount = 0;
    private GameData game;

    public GiftData(String giftName,FileConfiguration yml){
        this.game = Main.gameData;
        String str = "礼物设置."+giftName+".";
        this.giftName = giftName;
        this.comple_type = "NULL";
        if(yml.getString(str+"进度") != null){
            String[] stringSp = yml.getString(str+"进度").split("#");
            String tpye = stringSp[0];
            int a = Integer.parseInt(stringSp[1]);
            this.comple_type = tpye;
            this.amount = a;
        }
        this.sounds = "NULL";
        if(yml.getString(str+"声音") != null){
            this.sounds = yml.getString(str+"声音");
        }
        this.event = yml.getString(str + "效果");
        if (comple_type.equalsIgnoreCase("NULL")) {
            Bukkit.getConsoleSender().sendMessage("事件: " + this.event + "  条件: " + giftName);
        }else{
            if(comple_type.equalsIgnoreCase("take")){
                Bukkit.getConsoleSender().sendMessage("事件: " + this.event + "  条件: " + giftName+"  减"+amount+"赢");
            } else if(comple_type.equalsIgnoreCase("add")){
                Bukkit.getConsoleSender().sendMessage("事件: " + this.event + "  条件: " + giftName+"  加"+amount+"赢");
            }
        }
    }

    public String getGiftName() {
        return giftName;
    }

    public String getEvent() {
        return event;
    }

    public String getComple_Show() {
        if(comple_type.equalsIgnoreCase("take")){
            return "§c赢-"+amount;
        }else if(comple_type.equalsIgnoreCase("add")){
            return "§b赢+"+amount;
        }
        return "";
    }

    public void OutCompleEvent(int amount) {
        int new_amount = this.amount * amount;
        if(comple_type.equalsIgnoreCase("take")){
            Main.gameData.effect_takeComplete(new_amount);
            Bukkit.broadcastMessage("§c[系统]§a今日挑战进度: §c-"+new_amount);
        } else if(comple_type.equalsIgnoreCase("add")){
            Main.gameData.effect_addComplete(new_amount);
            Bukkit.broadcastMessage("§c[系统]§a今日挑战进度: §b+"+new_amount);
        }
    }
    public void OutPlaySoundsEvent() {
        if(!sounds.equalsIgnoreCase("NULL")) {
            GameUtil.SendAllSounds(sounds);
        }
    }

}
