package me.Demon.BlockWars.LiveEvent;

import cn.hamster3.cdapi.CDTimeAPI;
import com.yaohun.bwaddon.api.ExtendAPI;
import me.Demon.BlockWars.Game.EffectEntity;
import me.Demon.BlockWars.Game.EffectTime;
import me.Demon.BlockWars.Game.EffectTnt;
import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Manager.MinerOperate;
import me.Demon.BlockWars.Util.GameUtil;
import me.Demon.BlockWars.Util.RandomUtil;
import me.Demon.BlockWars.api.ExtendEffectAPI;
import org.bukkit.Bukkit;
import org.bukkit.EntityEffect;
import org.bukkit.Location;
import org.bukkit.Sound;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.util.Vector;

import java.util.HashMap;
import java.util.Map;

public class GiftEventHandler {

    public static void SendHandLer(Player zhubo,String userName,String eventName){
        GameData game = Main.gameData;
        userName = GameUtil.HideName(userName);
        if (eventName.equalsIgnoreCase("炸弹")) {
            EffectTnt.callPlayerTntDrop(zhubo,1);
            zhubo.playSound(zhubo.getLocation(),"jujueno",1.0F,1.0F);
        } else if (eventName.contains("炸弹X")) {
            String[] eventSp = eventName.split("X");
            int amount = Integer.parseInt(eventSp[1]);
            EffectTnt.callPlayerTntDrop(zhubo,amount);
        } else if (eventName.contains("TNTX")) {
            String[] eventSp = eventName.split("X");
            int amount = Integer.parseInt(eventSp[1]);
            EffectTnt.callPlayerTntDrop(zhubo,amount);
        } else if (eventName.equalsIgnoreCase("小雷王")) {
            EffectTnt.callPlayerTntDrop(zhubo,1);
        }else if (eventName.equalsIgnoreCase("三响炮")) {
            EffectTnt.callPlayerTntDrop(zhubo,3);
        } else if (eventName.equalsIgnoreCase("TNT10")) {
            EffectTnt.callPlayerTntDrop(zhubo,10);
        } else if (eventName.equalsIgnoreCase("TNT100")) {
            EffectTnt.callPlayerTntDrop(zhubo,100);
        } else if (eventName.equalsIgnoreCase("TNT1000")) {
            EffectTnt.callPlayerTntDrop(zhubo,1000);
        } else if (eventName.equalsIgnoreCase("TNT99999")) {
            EffectTnt.callForBombDrops(zhubo,5500);
            EffectTime.effectJumpSkyTnt(zhubo, 40);
        } else if (eventName.equalsIgnoreCase("TNT120")) {
            EffectTnt.callForBombDrops(zhubo,120);
        } else if (eventName.equalsIgnoreCase("TNT150")) {
            EffectTnt.callForBombDrops(zhubo,150);
        } else if (eventName.equalsIgnoreCase("TNT200")) {
            EffectTnt.callForBombDrops(zhubo,200);
        } else if (eventName.equalsIgnoreCase("TNT300")) {
            EffectTnt.callForBombDrops(zhubo,300);
        } else if (eventName.equalsIgnoreCase("TNT500")) {
            EffectTnt.callForBombDrops(zhubo,500);
        } else if (eventName.equalsIgnoreCase("TNT520")) {
            EffectTnt.callForBombDrops(zhubo,520);
        } else if (eventName.equalsIgnoreCase("TNT1200")) {
            EffectTnt.callForBombDrops(zhubo,1200);
        } else if (eventName.equalsIgnoreCase("TNT1600")) {
            EffectTnt.callForBombDrops(zhubo,1600);
        } else if (eventName.equalsIgnoreCase("TNT2000")) {
            EffectTnt.callForBombDrops(zhubo,2000);
        } else if (eventName.equalsIgnoreCase("TNT3200")) {
            EffectTnt.callForBombDrops(zhubo,2500);
        } else if (eventName.equalsIgnoreCase("TNT5000")) {
            EffectTnt.callForBombDrops(zhubo,4000);
        } else if (eventName.equalsIgnoreCase("修复一层")) {
            MinerOperate.repairBlock();
        } else if (eventName.equalsIgnoreCase("修复三层")) {
            for (int i = 0; i < 3;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },35L);
        } else if (eventName.equalsIgnoreCase("修复九层")) {
            for (int i = 0; i < 9;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },95L);
        } else if (eventName.equalsIgnoreCase("修复10层")) {
            for (int i = 0; i < 10;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },105L);
        }else if (eventName.equalsIgnoreCase("修复15层")) {
            for (int i = 0; i < 10;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },105L);
        }else if (eventName.equalsIgnoreCase("修复20层")) {
            for (int i = 0; i < 20;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },205L);
        }else if (eventName.equalsIgnoreCase("修复25层")) {
            for (int i = 0; i < 25;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },255L);
        }else if (eventName.equalsIgnoreCase("修复30层")) {
            for (int i = 0; i < 30;i++){
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    MinerOperate.repairBlock();
                    for (Player player : Bukkit.getOnlinePlayers()){
                        player.teleport(Main.gameData.getRegion().getHub());
                    }
                },i*10L);
            }
            Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                Main.gameData.refreshTheNonBlankBlockOfMiningArea(); // 刷新矿区当前块数量
            },305L);
        } else if (eventName.equalsIgnoreCase("修复全部")) {
            MinerOperate.fillMinerAll(game.getBlockRegionList());
        } else if (eventName.equalsIgnoreCase("清空砖块") || eventName.equalsIgnoreCase("别玩了吧") || eventName.equalsIgnoreCase("清空所有")) {
            MinerOperate.clearMinerAll(game.getBlockRegionList());
        } else if (eventName.equalsIgnoreCase("大风车")) {
            EffectEntity.effect_Rotate_360(zhubo);
        } else if (eventName.equalsIgnoreCase("重置矿区") || eventName.equalsIgnoreCase("场地重置")|| eventName.equalsIgnoreCase("矿区重置")) {
            ExtendEffectAPI.resetMinerSize();
            new BukkitRunnable() {
                @Override
                public void run() {
                    MinerOperate.initializeMinerSize();
                    zhubo.teleport(game.getRegion().getHub());
                }
            }.runTaskLater(Main.plugin,20L);
        } else if (eventName.equalsIgnoreCase("黑洞")) {
            EffectTime.effectBlackHoleBlock(zhubo);
        } else if (eventName.equalsIgnoreCase("完成一局")) {
            game.effect_addComplete(1);
        }else if (eventName.contains("完成加")) {
            String[] eventSp = eventName.split("加");
            int amount = getChainAmount(eventSp[1]);
            game.effect_addComplete(amount);
            zhubo.playEffect(EntityEffect.TOTEM_RESURRECT);
            zhubo.getWorld().strikeLightningEffect(zhubo.getLocation());
            zhubo.playSound(zhubo.getLocation(),"waou",1.0F,1.0F);
        }else if (eventName.contains("完成减")) {
            String[] eventSp = eventName.split("减");
            int amount = getChainAmount(eventSp[1]);
            game.effect_takeComplete(amount);
            zhubo.playEffect(EntityEffect.TOTEM_RESURRECT);
            zhubo.getWorld().strikeLightningEffect(zhubo.getLocation());
            zhubo.playSound(zhubo.getLocation(),"waou",1.0F,1.0F);
        }else if (eventName.equalsIgnoreCase("精神攻击")) {
            int random_int = RandomUtil.getRandomInt(0,100);
            if(random_int >= 70) {
                zhubo.playSound(zhubo.getLocation(), "cf_lailelaodi", 2, 1);
            }else if(random_int >= 40){
                zhubo.playSound(zhubo.getLocation(), "cf_taixunle", 2, 1);
            }else{
                zhubo.playSound(zhubo.getLocation(), "cf_xingbuxinga", 5, 1);
            }
        } else if (eventName.equalsIgnoreCase("螺旋升天")) {
            EffectTime.effectJumpSkyTnt(zhubo, 10);
            zhubo.playSound(zhubo.getLocation(),"dxj",1,1);
        } else if (eventName.equalsIgnoreCase("芜湖起飞")) {
            EffectTnt.effect_jump_tnt(zhubo);
        } else if (eventName.equalsIgnoreCase("坤坤冲击")) {
            EffectTime.effect_moveBlock(zhubo);
        }else if (eventName.contains("猪猪X")) {
            String[] eventSp = eventName.split("X");
            int amount = Integer.parseInt(eventSp[1]);
            EffectEntity.effect_spawn_pig(zhubo,userName,amount);
        }else if (eventName.equalsIgnoreCase("猪猪来咯")) {
            EffectEntity.effect_spawn_pig(zhubo,userName,2);
        }else if (eventName.equalsIgnoreCase("猪猪")) {
            EffectEntity.effect_spawn_pig(zhubo,userName,1);
        }else if (eventName.contains("小绿人X")) {
            String[] eventSp = eventName.split("X");
            int amount = Integer.parseInt(eventSp[1]);
            EffectEntity.effect_spawn_Zombie(zhubo,userName,amount);
        }else if (eventName.contains("钢铁人X")) {
            String[] eventSp = eventName.split("X");
            int amount = Integer.parseInt(eventSp[1]);
            EffectEntity.effect_spawn_IronGolem(zhubo,userName,amount);
        }else{
            Bukkit.broadcastMessage("§c[系统]§a触发效果 §e"+eventName+" §a不存在.");
        }
    }

    private static final Map<String, Integer> amountMap = new HashMap<>();
    static {
        amountMap.put("一", 1);
        amountMap.put("二", 2);
        amountMap.put("三", 3);
        amountMap.put("四", 4);
        amountMap.put("五", 5);
        amountMap.put("六", 6);
        amountMap.put("七", 7);
        amountMap.put("八", 8);
        amountMap.put("九", 9);
        amountMap.put("十", 10);
        amountMap.put("十一", 11);
        amountMap.put("十二", 12);
        amountMap.put("十三", 13);
        amountMap.put("十四", 14);
        amountMap.put("十五", 15);
        amountMap.put("十六", 16);
        amountMap.put("十七", 17);
        amountMap.put("十八", 18);
        amountMap.put("十九", 19);
        amountMap.put("二十", 20);
    }
    public static int getChainAmount(String amountKey) {
        return amountMap.getOrDefault(amountKey, 1);
    }
}
