package me.Demon.BlockWars.Data;

import de.tr7zw.nbtapi.NBTItem;
import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.GameUtil;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import java.util.ArrayList;
import java.util.List;

public class GameEditGui implements Listener {

    public static String invTitle = "我的世界整蛊 - 游戏设置管理";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        int rawSlot = e.getRawSlot();
        Player zhubo = (Player) e.getWhoClicked();
        ItemStack item = e.getCurrentItem();
        if(e.getView().getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            if(item == null || item.getType() == Material.AIR){
                return;
            }
        }
    }

    public static void OpenGui(Player p){
        Inventory inv = Bukkit.createInventory(null,36,invTitle);
        inv.setItem(26,Edit_Comparator());
        p.openInventory(inv);
    }

    public static ItemStack Edit_Comparator(){
        ItemStack item = new ItemStack(Material.COMPARATOR);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §a游戏参数设置");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add("§c回车或T键打开聊天栏点击设置");
        lore.add(" ");
        lore.add("§b★ §6鼠标点击 §7查看参数设置");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack Rest_Server(){
        ItemStack item = new ItemStack(Material.PAPER);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§d★ §e重启游戏");
        List<String> lore = new ArrayList<>();
        lore.add("§8By.AuroraPixel");
        lore.add("§c重启后修改参数将生效");
        lore.add(" ");
        lore.add("§b★ §6鼠标点击 §7开始重启");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.setCustomModelData(55);
        item.setItemMeta(meta);
        return item;
    }
}
