package me.Demon.BlockWars.Listener;

import cn.hamster3.cdapi.CDTimeAPI;
import me.Demon.BlockWars.Game.EffectTnt;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.RandomUtil;
import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.Effect;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.util.Vector;

import java.util.UUID;

public class GameEffect implements Listener {

    public static int skyTnt = 0;
    public static int skyTntSound = 0;

    @EventHandler
    public void onQuitRemoveEffect(PlayerQuitEvent e){
        Player p = e.getPlayer();
        CDTimeAPI.setPlayerCD(p.getUniqueId(),"skyTnt",500);
        CDTimeAPI.setPlayerCD(p.getUniqueId(),"move_remove_block",500);
    }

    @EventHandler
    public void onplace(PlayerMoveEvent e) {
        Player p = e.getPlayer();
        UUID uuid = p.getUniqueId();
        Location loc = p.getLocation();
        if(CDTimeAPI.getCD(uuid,"skyTnt") >= 1){
            long milliseconds = CDTimeAPI.getCD(uuid, "skyTnt");
            double seconds = (double) milliseconds / 1000;
            String message = "§6螺旋升天倒计时: §b" + String.format("%.1f", seconds) + "秒";
            p.sendTitle("§c§l"+String.format("%.1f",p.getLocation().getY())+"米","§e当前海拔高度",0,25,5);
            p.spigot().sendMessage(ChatMessageType.ACTION_BAR,new TextComponent(message));
            String skyTntCdKey = "skyTntCd";
            long skyTntCd = CDTimeAPI.getCD(uuid,skyTntCdKey);
            if(skyTntCd < 1) {
                CDTimeAPI.setPlayerCD(uuid,skyTntCdKey,250);
                new BukkitRunnable() {
                    public void run() {
                        double radius = 1.0;
                        double angleStep = Math.PI / 4;
                        double angle = skyTnt * angleStep;
                        Vector vector = new Vector(radius * Math.cos(angle), 0.5, radius * Math.sin(angle));
                        p.setVelocity(vector);
                        skyTnt++;
                        skyTntSound++;
                        if (skyTnt >= 8) {
                            skyTnt = 0;
                        }
                        if (skyTntSound >= 10) {
                            skyTntSound = 0;
                            p.playSound(p.getLocation(),"dxj",1,1);
                        }
                        cancel();
                    }
                }.runTaskLater(Main.plugin, 5L);
            }
            new BukkitRunnable() {
                public void run() {
                    EffectTnt.spawnTNT(p.getLocation().add(0, -1.3D, 0), 50, 4);
                    cancel();
                }
            }.runTaskLater(Main.plugin, 10L);
        }
    }

    @EventHandler
    public void onMove(PlayerMoveEvent e){
        Player p = e.getPlayer();
        UUID uuid = p.getUniqueId();
        Location loc = p.getLocation();
        World world = loc.getWorld();
        if(CDTimeAPI.getCD(uuid,"move_remove_block") >= 1) {
            if (CDTimeAPI.getCD(uuid, "move_kk_cd") >= 1) {
                return;
            }
            if(p.isFlying()) {
                p.setFlying(false);
            }
            if(!Main.gameData.getRegion().isInRegionPlayer(loc)){
                p.teleport(Main.gameData.getRegion().getHub().add(0,-2,0));
            }
            p.playSound(p.getLocation(),"ji",0.5F,1);
            long milliseconds = CDTimeAPI.getCD(uuid, "move_remove_block");
            double seconds = (double) milliseconds / 1000;
            Vector launchVector = new Vector(RandomUtil.getRandomDouble(-1, 1, 1), 0, RandomUtil.getRandomDouble(-1, 1, 1));
            p.setVelocity(launchVector);
            String message = "§6坤坤冲击倒计时: §b" + String.format("%.1f", seconds) + "秒";
            p.spigot().sendMessage(ChatMessageType.ACTION_BAR,new TextComponent(message));
            CDTimeAPI.setPlayerCD(uuid, "move_kk_cd", 100);
            world.playEffect(loc, Effect.MOBSPAWNER_FLAMES, 10);
            // 清理3x3区域的方块
            for (int x = -1; x <= 1; x++) {
                for (int y = -1; y <= 2; y++) {
                    for (int z = -1; z <= 1; z++) {
                        Block block = world.getBlockAt(loc.clone().add(x,y,z));
                        if (Main.gameData.getRegion().isInRegion(block.getLocation())) {
                            block.setType(org.bukkit.Material.AIR);
                        }
                    }
                }
            }
        }
    }
}
