package me.Demon.BlockWars.LiveEvent;

import com.io.yutian.mclive.event.LiveGiftEvents;
import com.yaohun.RandomBox.api.RBoxAPI;
import com.yaohun.bwaddon.api.ExtendAPI;
import me.Demon.BlockWars.Data.GiftData;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.ConfigYml;
import me.Demon.BlockWars.Util.GameUtil;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class GiftListener implements Listener {

    @EventHandler
    public void onGfit(LiveGiftEvents e) {
        Player zhubo = e.getPlayer();
        String userName = ""+ RandomUtil.getRandomInt(10000,90000);
        boolean butt = false;
        if(e.getUser().nickName() != null) {
            userName = e.getUser().nickName();
            butt = true;
        }
        String giftName = e.getName();
        int amount = (int) e.getAmount();
        if (amount <= 0) {
            amount = 1;
        }
        ConfigYml configYml = Main.configYml;
        if(configYml.getGiftData(giftName) == null){
            return;
        }
        GiftData giftData = configYml.getGiftData(giftName);
        giftData.OutCompleEvent(amount);
        String eventName = giftData.getEvent();
        String show_userName =  GameUtil.HideName(userName);
        if(GameUtil.specialGiftEffectTriggers(zhubo,eventName,show_userName,amount)){
            return;
        }
        String title = "§c" + eventName;
        if(amount >= 2) {
            title = "§c" + eventName + " x" + amount;
        }
        String subtitle = "§9" + giftName;
        if(butt) {
            subtitle = "§9" + show_userName;
        }
        zhubo.sendTitle(title, subtitle,0, 30, 10);
        if (amount <= 1) {
                giftData.OutPlaySoundsEvent();
                GiftEventHandler.SendHandLer(zhubo, userName, eventName);
        } else {
            long dadey = 5L;
            for (int i = 0; i < amount; i++) {
                String finalUserName = userName;
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    giftData.OutPlaySoundsEvent();
                    GiftEventHandler.SendHandLer(zhubo, finalUserName, eventName);
                }, (long) i * dadey);
            }
        }
        for (Player player : Bukkit.getOnlinePlayers()){
            player.sendMessage("§a礼物: §e"+ show_userName+" §d送来了 §e"+giftName+"x"+amount);
        }
    }
}
