package me.Demon.BlockWars.Util;

import me.Demon.BlockWars.Data.GiftData;
import me.Demon.BlockWars.Main;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class ConfigYml {
    private int countdownTime;
    private int dianzan_amount;
    private int dianzan_need;
    private String dianzan_event;
    private HashMap<String,List<String>> randonBoxList = new HashMap<>();
    private HashMap<String, Integer> gameSettings = new HashMap<>();
    private HashMap<String, GiftData> giftData = new HashMap<>();
    public ConfigYml(){
        this.dianzan_amount = 0;
        FileConfiguration settings_yml = Main.plugin.getConfig();
        this.countdownTime = settings_yml.getInt("countdownTime");
        Bukkit.getConsoleSender().sendMessage("[日志 - 炸弹填充] 游戏设置:");
        if(settings_yml.getConfigurationSection("Settings") != null){
            for (String buttKey : settings_yml.getConfigurationSection("Settings").getKeys(false)){
                int settings_type = settings_yml.getInt("Settings."+buttKey);
                gameSettings.put(buttKey, settings_type);
                Bukkit.getConsoleSender().sendMessage("设置: "+buttKey+"  "+getSwitchString(settings_type));
            }
        }
        // 注册直播互动事件
        FileConfiguration gift_yml = Main.giftYml;
        LoadDianEvent(Main.giftYml);
        Bukkit.getConsoleSender().sendMessage("[日志 - 炸弹填充] 事件注册:");
        if(gift_yml.getConfigurationSection("礼物设置") != null){
            Bukkit.getConsoleSender().sendMessage("事件: 盲盒  数量: "+randonBoxList.size()+"个");
            Bukkit.getConsoleSender().sendMessage("事件: "+this.getDianzan_event()+"  条件: 点赞x"+this.getDianzan_need());
            for (String giftName : gift_yml.getConfigurationSection("礼物设置").getKeys(false)){
                giftData.put(giftName,new GiftData(giftName,gift_yml));
            }
        }
    }

    public void LoadDianEvent(FileConfiguration yml){
        this.dianzan_need = 300;
        if(yml.getInt("点赞整蛊.点赞次数") >= 1){
            this.dianzan_need = yml.getInt("点赞整蛊.点赞次数");
        }
        this.dianzan_event = "小雷王";
        if(yml.getString("点赞整蛊.效果") != null){
            this.dianzan_event = yml.getString("点赞整蛊.效果");
        }
    }

    public boolean isGameSettings(String buttKey){
        if(gameSettings.get(buttKey) != null){
            int type = gameSettings.get(buttKey);
            if(type == 1){
                return true;
            }
        }
        return false;
    }
    public int getGameSettings(String buttKey){
        if(gameSettings.get(buttKey) != null){
            return gameSettings.get(buttKey);
        }
        return 0;
    }

    public void setGameSettings(String buttKey,int settings_type){
        if(gameSettings.get(buttKey) != null){
            gameSettings.put(buttKey,settings_type);
        }
        gameSettings.put(buttKey,settings_type);
    }

    public int getDianzan_need() {
        return dianzan_need;
    }

    public String getDianzan_event() {
        return dianzan_event;
    }

    public int getCountdownTime() {
        return countdownTime;
    }
    public String getSwitchString(int butt){
        if(butt == 1){
            return "开启";
        }
        return "关闭";
    }
    public int getDianzan_amount() {
        return dianzan_amount;
    }
    public void addDianzan_amount(int add_amount){
        setDianzan_amount(dianzan_amount+add_amount);
    }
    public void setDianzan_amount(int dianzan_amount) {
        this.dianzan_amount = dianzan_amount;
    }
    public GiftData getGiftData(String giftName){
        if(this.giftData.get(giftName) != null){
            return this.giftData.get(giftName);
        }
        return null;
    }
    public HashMap<String, GiftData> getGiftData() {
        return giftData;
    }
}
