package me.Demon.BlockWars.Util;

import com.io.yutian.mclive.event.ZhuboAPI;
import com.yaohun.RandomBox.api.RBoxAPI;
import com.yaohun.bwaddon.api.ExtendAPI;
import me.Demon.BlockWars.Data.GiftData;
import me.Demon.BlockWars.LiveEvent.GiftEventHandler;
import me.Demon.BlockWars.Main;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

public class GiftUtil {

    public static void simulateEventEffect(Player player,String userName, String eventName, int amount){
        if (!ZhuboAPI.isWsRoomIdSame(player)) {
            player.sendMessage("§c[系统]§a游戏需要连接弹幕抓取软件后才能正常使用此功能.");
            return;
        }
        if(GameUtil.specialGiftEffectTriggers(player,eventName,userName,1)){
            return;
        }
        GiftEventHandler.SendHandLer(player, userName, eventName);
    }

    public static void simulatedGiftEffect(Player player,String userName, String giftName, int amount){
        ConfigYml configYml = Main.configYml;
        if(configYml.getGiftData(giftName) == null){
            return;
        }
        if (!ZhuboAPI.isWsRoomIdSame(player)) {
            player.sendMessage("§c[系统]§a游戏需要连接弹幕抓取软件后才能正常使用此功能.");
            return;
        }
        GiftData giftData = configYml.getGiftData(giftName);
        giftData.OutCompleEvent(amount);
        String show_userName =  GameUtil.HideName(userName);
        String eventName = giftData.getEvent();
        if(GameUtil.specialGiftEffectTriggers(player,eventName,show_userName,amount)){
            return;
        }
        if (amount <= 1) {
            giftData.OutPlaySoundsEvent();
            GiftEventHandler.SendHandLer(player, userName, eventName);
        } else {
            long dadey = 5L;
            for (int i = 0; i < amount; i++) {
                Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                    giftData.OutPlaySoundsEvent();
                    GiftEventHandler.SendHandLer(player, userName, eventName);
                }, (long) i * dadey);
            }
        }
    }
}
