package me.Demon.BlockWars.api;

import com.yaohun.RandomBox.api.RBoxAPI;
import com.yaohun.bwaddon.api.ExtendAPI;
import me.Demon.BlockWars.Data.GiftData;
import me.Demon.BlockWars.Game.BlockRegion;
import me.Demon.BlockWars.Game.GameData;
import me.Demon.BlockWars.Game.Region;
import me.Demon.BlockWars.LiveEvent.GiftEventHandler;
import me.Demon.BlockWars.Main;
import me.Demon.BlockWars.Util.ConfigYml;
import me.Demon.BlockWars.Util.GameUtil;
import me.Demon.BlockWars.Util.GiftUtil;
import me.Demon.BlockWars.Util.RandomUtil;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class BlockWarsAPI {

    // 获取游戏Data
    public static GameData getGameData(){
        return Main.gameData;
    }

    // 获取区域
    public static Region getGameRegion(){
        return getGameData().getRegion();
    }
    // 获取异步区块
    public static List<BlockRegion> getBlockRegionList(){
        return getGameData().getBlockRegionList();
    }
    public static void refreshBlock(){
        getGameData().refreshBlockRgionList(32);
    }
    public static void sendSimulatedGiftEffect(Player player,String userName,String giftName,int amount){
        GiftUtil.simulatedGiftEffect(player,userName,giftName,amount);
    }
    public static void sendSimulateEventEffect(Player player,String userName,String eventName,int amount){
        GiftUtil.simulateEventEffect(player,userName,eventName,amount);
    }
}
